#import <Foundation/Foundation.h>
#import <Cordova/CDV.h>
#import <V-Tap/VTapManager.h>

@interface VTapPlugin : CDVPlugin
// /********************* Setup and Lifecycle action *********************/
// 		ACT_GET_TRUSTED_TIME : "act_get_trusted_time",
-(void)act_get_instance:(CDVInvokedUrlCommand *)command;
-(void)act_setup_vtap:(CDVInvokedUrlCommand *)command;
-(void)act_vtap_resume:(CDVInvokedUrlCommand *)command;
-(void)act_vtap_pause:(CDVInvokedUrlCommand *)command;
-(void)act_vtap_destroy:(CDVInvokedUrlCommand *)command;
-(void)act_set_hostname:(CDVInvokedUrlCommand *)command;
-(void)act_set_pki_hostname:(CDVInvokedUrlCommand *)command;
-(void)act_set_ti_server_url:(CDVInvokedUrlCommand *)command;
-(void)act_get_trusted_time:(CDVInvokedUrlCommand *)command;
-(void)act_set_allow_auto_sending_troubleshooting_log:(CDVInvokedUrlCommand *)command;
-(void)act_set_allow_send_stacktrace_log:(CDVInvokedUrlCommand *)command;
-(void)act_sdk_version:(CDVInvokedUrlCommand *)command;
-(void)act_reset_vos_trusted_storage:(CDVInvokedUrlCommand *)command;

// 		/********************* Device Compatibility action *********************/
-(void)act_device_compatibility:(CDVInvokedUrlCommand *)command;
-(void)act_send_device_info:(CDVInvokedUrlCommand *)command;

//   	/********************** Provisioning action ****************************/
-(void)act_provisioning_done:(CDVInvokedUrlCommand *)command;
-(void)act_all_provisioned_token:(CDVInvokedUrlCommand *)command;
-(void)act_token_type:(CDVInvokedUrlCommand *)command;
-(void)act_dfp_hash:(CDVInvokedUrlCommand *)command;
-(void)act_get_load_ack_token_firmware:(CDVInvokedUrlCommand *)command;
-(void)act_load_token_firmware:(CDVInvokedUrlCommand *)command;
-(void)act_validate_checksum_true:(CDVInvokedUrlCommand *)command;
-(void)get_pki_token_serial:(CDVInvokedUrlCommand *)command;
-(void)act_get_token_serial:(CDVInvokedUrlCommand *)command;
-(void)act_token_firmware_version:(CDVInvokedUrlCommand *)command;
-(void)act_remove_token:(CDVInvokedUrlCommand *)command;
-(void)act_load_token:(CDVInvokedUrlCommand *)command;
-(void)act_unload_token:(CDVInvokedUrlCommand *)command;
-(void)act_set_token_pin:(CDVInvokedUrlCommand *)command;
-(void)act_token_pin_remembered:(CDVInvokedUrlCommand *)command;
-(void)act_check_token_pin:(CDVInvokedUrlCommand *)command;
-(void)act_check_token_pin_seed:(CDVInvokedUrlCommand *)command;
-(void)act_change_token_pin:(CDVInvokedUrlCommand *)command;
-(void)act_token_registered:(CDVInvokedUrlCommand *)command;
-(void)act_get_troubleshooting_id:(CDVInvokedUrlCommand *)command;
-(void)act_send_troubleshooting_logs:(CDVInvokedUrlCommand *)command;

// 		/*************************** OTP action ********************************/
-(void)act_set_otp_length:(CDVInvokedUrlCommand *)command;
-(void)act_generate_totp:(CDVInvokedUrlCommand *)command;
-(void)act_generate_cr:(CDVInvokedUrlCommand *)command;
-(void)act_generate_txs:(CDVInvokedUrlCommand *)command;

// 		/*************************** PKI action ********************************/
-(void)act_generate_csr_and_send:(CDVInvokedUrlCommand *)command;
-(void)act_trigger_cert_push_notification:(CDVInvokedUrlCommand *)command;
-(void)act_pki_cert_download:(CDVInvokedUrlCommand *)command;
-(void)act_pki_cert_download_retry:(CDVInvokedUrlCommand *)command;
-(void)act_generate_csr_and_send_sync:(CDVInvokedUrlCommand *)command;
-(void)act_pki_function_registered:(CDVInvokedUrlCommand *)command;
-(void)act_pki_function_pin_remembered:(CDVInvokedUrlCommand *)command;
-(void)act_pki_function_check_pin:(CDVInvokedUrlCommand *)command;
-(void)act_pki_function_change_pin:(CDVInvokedUrlCommand *)command;
-(void)act_remove_pki_function:(CDVInvokedUrlCommand *)command;
-(void)act_push_notification_register:(CDVInvokedUrlCommand *)command;
-(void)act_push_notification_regsiter_with_type:(CDVInvokedUrlCommand *)command;
-(void)act_registered_user_id:(CDVInvokedUrlCommand *)command;
-(void)act_registered_device_id:(CDVInvokedUrlCommand *)command;
-(void)act_pki_function_authenticate:(CDVInvokedUrlCommand *)command;
-(void)act_pki_function_doc_sign:(CDVInvokedUrlCommand *)command;
-(void)act_vmessage_decrypt:(CDVInvokedUrlCommand *)command;
-(void)act_vmessage_download:(CDVInvokedUrlCommand *)command;
-(void)act_message_ack:(CDVInvokedUrlCommand *)command;
-(void)act_set_additional_data:(CDVInvokedUrlCommand *)command;
-(void)act_get_additional_data:(CDVInvokedUrlCommand *)command;
-(void)act_disable_additional_data:(CDVInvokedUrlCommand *)command;
-(void)act_set_message_data_type:(CDVInvokedUrlCommand *)command;
-(void)act_get_cert:(CDVInvokedUrlCommand *)command;

@end
